%%%%%%%%%%
%%%%%this is the stimulus creation program for the b8 stimuli
%%%%%51 stimuli in all. These were presented at 1, 2, 4 or 8 rotations
%%%%%based on rotational symmetry
%%%%%to create the stimuli, in addition to this program you need:
%%%%%vertices1.txt
%%%%%fvmax.m
%%%%%At the matlab prompt type the name of this program. When prompted for
%%%%%the stimulus number, type a number between 1 and 51.

fidr = fopen('vertices1.txt', 'r');
idx = 0;
neigh = 200;
ang = [0 7*pi/4 3*pi/2 5*pi/4 pi 3*pi/4 pi/2 pi/4];
%j = input('Enter Stimulus number (1:51): ');
for i = 1:51
  vrtnum = fscanf(fidr, '%d', [1, 1]);
  disp(vrtnum);
  in = (fscanf(fidr, '%f', [2, vrtnum]))';
  %if(j == i)
%     figure('Position',[200 200 516 490]);
    figure('Position',[200 200 256 244]);
    bufvert = fvmax(in);
    %subplot(2,2,1); 
    fill([-3.0 3.0 3.0 -3.0], [-3.0 -3.0 3.0 3.0], 'k', 'EdgeColor', 'none');
    hold
    plot(bufvert(:,1),bufvert(:,2),'w');
    axis([-3 3 -3 3])
    a = getframe;
    b = zeros(neigh,neigh);
    c = 0.2990*a.cdata(:,:,1)+0.5870*a.cdata(:,:,2)+0.1140*a.cdata(:,:,3);
    for j=1:length(ang)
      rot = [cos(ang(j))    sin(ang(j))   0
             -sin(ang(j))   cos(ang(j))   0
             0              0             1];
      tform_rot = maketform('affine',rot);
      d = imtransform(c,tform_rot,'nearest');
      if(size(d)>[neigh neigh])
        b = d((size(d,1)-neigh)/2+1:size(d,1)-(size(d,1)-neigh)/2, ...
         (size(d,2)-neigh)/2+1:size(d,2)-(size(d,2)-neigh)/2);
      else
        b = d;
      end
      imwrite(b, strcat(num2str(i),'_',num2str(j),'.png'),'png');
    end
  %end
end
fclose(fidr);
